#!/bin/bash

BASEDIR=$(dirname "$0")

#Install dependencies
apt-get update
apt-get -y install bison cmake flex g++ gdb make libmagic-dev libpcap-dev libgeoip-dev libssl-dev python-dev swig2.0 zlib1g-dev
apt-get -y install p7zip-full
apt-get -y install libjemalloc1
apt-get -y install libtcmalloc-minimal4

cp $BASEDIR/libraries/libcrypto.so.10 /usr/lib/
cp $BASEDIR/libraries/libssl.so.10 /usr/lib/

#Add bro binaries to PATH
bash -c "echo 'export PATH=\$PATH:/usr/local/bro/bin' > /etc/profile.d/bro.sh"
source /etc/profile.d/bro.sh

clear

#Valkyrie Verdict API Key
echo "Enter Valkyrie-Verdict API Key:"
read API_KEY
echo $API_KEY > api_key
cp api_key $BASEDIR/packages/valkyrie_network_sensor/network_sensor/api_key
rm api_key

#NIC Configuration
echo "Enter network interface adapter name:"
read ADAPTER_NAME
echo $ADAPTER_NAME > nic_conf
cp nic_conf $BASEDIR/packages/valkyrie_network_sensor/network_sensor/nic_conf
rm nic_conf
#ethtool -K $ADAPTER_NAME gro off rx off tx off gso off

#Bro Configuration
echo "[manager]" > $BASEDIR/packages/bro/etc/node.cfg
echo "type=manager" >> $BASEDIR/packages/bro/etc/node.cfg
echo "host=localhost" >> $BASEDIR/packages/bro/etc/node.cfg

echo "[proxy-1]" >> $BASEDIR/packages/bro/etc/node.cfg
echo "type=proxy" >> $BASEDIR/packages/bro/etc/node.cfg
echo "host=localhost" >> $BASEDIR/packages/bro/etc/node.cfg

echo "[worker-1]" >> $BASEDIR/packages/bro/etc/node.cfg
echo "type=worker" >> $BASEDIR/packages/bro/etc/node.cfg
echo "host=localhost" >> $BASEDIR/packages/bro/etc/node.cfg
echo "interface=$ADAPTER_NAME" >> $BASEDIR/packages/bro/etc/node.cfg
echo "lb_method=pf_ring" >> $BASEDIR/packages/bro/etc/node.cfg
echo "lb_procs=1" >> $BASEDIR/packages/bro/etc/node.cfg

if [ -f /usr/local/bro/bin/bro ]
then
	broctl stop
fi

clear

#kill old version
pkill -f /usr/local/bro/bin/bro -9
pkill -f /opt/valkyrie_network_sensor/network_sensor/venv/bin/python -9

cp -r $BASEDIR/packages/bro/ /usr/local/
cp -r $BASEDIR/packages/valkyrie_network_sensor/ /opt/

#/usr/local/bro/bin/broctl deploy

echo "[Unit]" > /etc/systemd/system/valkyrie_network_sensor.service
echo "Description=Valkyrie-Verdict Network Sensor Service " >> /etc/systemd/system/valkyrie_network_sensor.service
echo "[Service]" >> /etc/systemd/system/valkyrie_network_sensor.service
echo "Type=forking" >> /etc/systemd/system/valkyrie_network_sensor.service
echo "WorkingDirectory=/opt/valkyrie_network_sensor/network_sensor/"
echo "ExecStart=/opt/valkyrie_network_sensor/network_sensor/start_sensor.sh" >> /etc/systemd/system/valkyrie_network_sensor.service
#echo "Restart=on-failure" >> 

echo "[Install]" >> /etc/systemd/system/valkyrie_network_sensor.service
echo "WantedBy=multi-user.target" >> /etc/systemd/system/valkyrie_network_sensor.service

systemctl enable valkyrie_network_sensor
systemctl start valkyrie_network_sensor

#/opt/valkyrie_network_sensor/network_sensor/start_sensor.sh

