export
{
	# Define the file types we are interested in extracting
	const ext_map: table[string] of string = {
		["application/x-dosexec"] = "exe",
		["application/octet-stream"] = "exe",
		["application/x-gzip"] = "gz",
		["application/x-rar"] = "rar",
		["application/x-tar"] = "tar",
		["application/zip"] = "zip",
		##["application/x-archive"] = "",
		##["application/x-compress"] = "",
		##["application/x-executable"] = "",
		##["application/x-font-sfn"] = "",
		##["application/x-lzma"] = "",
		##["video/h264"] = "264",
		##["video/3gpp"] = "3gp",
		["application/x-7z-compressed"] = "7z"
		##["application/x-arc"] = "arc",
		##["application/x-arj"] = "arj",
		##["text/x-awk"] = "awk",
		##["image/x-ms-bmp"] = "bmp",
		##["application/vnd.ms-cab-compressed"] = "cab",
		##["application/x-coredump"] = "core",
		##["application/x-cpio"] = "cpio",
		##["image/x-cursor"] = "cur",
		##["application/x-dmg"] = "dmg",
		##["application/msword"] = "doc",
		##["application/vnd.openxmlformats-officedocument.wordprocessingml.document"] = "docx",
		##["application/x-eet"] = "eet",
		##["application/vnd.ms-fontobject"] = "eot",
		##["video/x-flc"] = "flc",
		##["video/x-fli"] = "fli",
		##["video/x-flv"] = "flv",
		##["image/gif"] = "gif",
		##["text/html"] = "html",
		##["image/x-icon"] = "ico",
		##["application/octet-stream"] = "iso",
		##["application/java-archive"] = "jar",
		##["application/x-java-applet"] = "jar",
		##["video/x-jng"] = "jng",
		##["application/x-java-jnlp-file"] = "jnlp",
		##["image/jpeg"] = "jpg",
		##["application/javascript"] = "js",
		##["text/json"] = "json",
		##["application/x-lha"] = "lha",
		##["application/x-lrzip"] = "lrz",
		##["text/x-lua"] = "lua",
		##["application/x-lz4"] = "lz4",
		##["application/x-lzh"] = "lzh",
		##["application/x-mif"] = "mif",
		##["video/mj2"] = "mj2",
		##["video/matroska"] = "mkv",
		##["video/x-mng"] = "mng",
		##["audio/mpeg"] = "mp3",
		##["audo/m4a"] = "mp4",
		##["video/mp4"] = "mp4",
		##["video/mpeg"] = "mpg",
		##["video/mpv"] = "mpv",
		##["application/vnd.ms-opentype"] = "otf",
		##["application/pkcs7-signature"] = "p7",
		##["application/vnd.tcpdump.pcap"] = "pcap",
		##["application/pdf"] = "pdf",
		##["application/x-pem"] = "pem",
		##["text/x-php"] = "php",
		##["application/x-xar"] = "pkg",
		##["text/x-perl"] = "pl",
		##["image/vnd.adobe.photoshop"] = "pnd",
		##["image/png"] = "png",
		##["application/vnd.openxmlformats-officedocument.presentationml.presentation"] = "pptx",
		##["text/x-python"] = "py",
		##["video/quicktime"] = "qt",
		##["text/x-ruby"] = "rb",
		##["application/x-rpm"] = "rpm",
		##["text/rss"] = "rss",
		##["text/rtf"] = "rtf",
		##["application/vnd.font-fontforge-sfd"] = "sfd",
		##["vidoe/x-sgi-movie"] = "sgi",
		##["text/x-shellscript"] = "sh",
		##["application/x-stuffit"] = "sif",
		##["application/x-shockwave-flash"] = "swf",
		##["image/tiff"] = "tiff",
		##["application/x-font-ttf"] = "ttf",
		##["text/plain"] = "txt",
		##["application/warc"] = "warc",
		##["video/webm"] = "webm",
		##["application/font-woff"] = "woff",
		##["application/vnd.openxmlformats-officedocument.spreadsheetml.sheet"] = "xlsx",
		##["application/xml"] = "xml",
		##["application/x-xz"] = "xz",
		##["application/x-zoo"] = "zoo",
	} &redef &default="";
}

# Set extraction folder
redef FileExtract::prefix = "/usr/local/bro/logs/extracted_files";

event file_sniff(f: fa_file, meta: fa_metadata)
{
	local ext = "";

	if ( meta?$mime_type )
	{
		ext = ext_map[meta$mime_type];
	}

	if ( ext == "" )
	{
		return;
	}
	# Hash the file for good measure
	Files::add_analyzer(f, Files::ANALYZER_SHA1);

	local fname = fmt("%s-%s.%s", f$source, f$id, ext);
	Files::add_analyzer(f, Files::ANALYZER_EXTRACT, [$extract_filename=fname]);
}
