import os
import logging
from logging.handlers import TimedRotatingFileHandler

class NetworkSensorGlobals:
    LOG_FILE = "network_sensor.log"
    LOG_PATH = "/var/log/valkyrie_network_sensor"
    __logger__ = None
    
    @classmethod
    def LOGGER(cls):
        if cls.__logger__ is None:
            if not os.path.exists(NetworkSensorGlobals.LOG_PATH):
                os.makedirs(NetworkSensorGlobals.LOG_PATH)
            # logger for logging
            print "Valkyrie Network_Sensor Initializing Logger..."
            handler = TimedRotatingFileHandler(os.path.join(NetworkSensorGlobals.LOG_PATH, NetworkSensorGlobals.LOG_FILE),  when="midnight", backupCount=30, utc=True)
            handler.setLevel(logging.DEBUG)
            formatter = logging.Formatter('%(asctime)s - %(name)s - %(levelname)s - %(component)s - %(message)s')
            handler.setFormatter(formatter)
            logger_static = logging.getLogger("general_logger")
            logger_static.setLevel(logging.DEBUG)
            logger_static.addHandler(handler)

            logger_extra = {'component': "Network_Sensor"}
            cls.__logger__ = logging.LoggerAdapter(logger_static, logger_extra)
            cls.__logger__.info("******************* Logger Initialized *******************")
            cls.__logger__.propagate = False
            print "Valkyrie Network_Sensor Logger Initialized..."

        return cls.__logger__
