import requests
import settings
import traceback
import os
from globals import NetworkSensorGlobals

class verdict_bro_manager:

    def __init__(self):
        try:
            self.logger = NetworkSensorGlobals.LOGGER()
            with open(os.path.join(os.path.dirname(os.path.realpath(__file__)), "api_key"), 'r') as f:
                self.api_key = f.read().splitlines()[0]
        except:
            self.logger.info("API Key from file cannot be read")
            print traceback.format_exc()

    def queryFileVerdict(self, sha1):
        self.logger.info("Querying Valkyrie-Verdict for file sha1: %s" %sha1)
        headers = {'X-Api-Key': self.api_key}
        url = 'https://developers.valkyrie.comodo.com/api/v1/file/query/' + sha1
        response = requests.request('GET', url, headers=headers)
        return response.text

    def scanFile(self, file_name, file_path):
        headers = {'X-Api-Key': self.api_key}
        url = 'https://developers.valkyrie.comodo.com/api/v1/file/scan'
        files = {'file_data': (file_name, open(file_path, 'rb'))}
        response = requests.request('POST', url, files=files, headers=headers)
        return response.text
